<template>
  <div :class="$style.tableWrapper">
    <table-title v-if="title">{{ title | upperCase }}</table-title>
    <table :class="$style.tableComponent">
      <table-row>
        <table-head v-for="(header, index) in tableHeaders" :key="index">{{
          header | upperCase
        }}</table-head>
      </table-row>
      <table-row
        v-for="(row, index) in tableData"
        :key="index"
        :class="$style.tableRow"
      >
        <table-cell
          v-for="(cell, index) in row"
          :isEditable="isEditable"
          :name="index"
          :key="index"
        >
          <!-- find better solution for base tag -->
          <base-tag
            :theme="cell"
            v-if="
              cell === 'Pending' || cell === 'Approved' || cell === 'Denied'
            "
            >{{ cell }}</base-tag
          >
          <span v-else>{{ cell }}</span>
        </table-cell>
      </table-row>
    </table>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
// @ts-ignore
import TableTitle from "./table-title";
// @ts-ignore
import TableHead from "./table-head/";
// @ts-ignore
import TableRow from "./table-row";
// @ts-ignore
import TableCell from "./table-cell";
// @ts-ignore
import BaseTag from "@/components/base/BaseTag";

interface TypeTableData {
  value: string;
  description: string;
}

export default Vue.extend({
  name: "BaseTable",
  components: {
    TableTitle,
    TableHead,
    TableRow,
    TableCell,
    BaseTag
  },
  props: {
    data: {
      type: Array,
      required: true
    },
    title: {
      type: String,
      required: false
    },
    titlesList: {
      type: Array,
      required: false
    },
    isEditable: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  computed: {
    tableHeaders: function() {
      return this.titlesList ? this.titlesList : this.data[0];
    },
    tableData: function() {
      if (this.titlesList) {
        return this.data;
      } else {
        const tableData = this.data.reduce((data: any, current, index) => {
          if (index > 0) {
            data.push(current);
            return data;
          }
          return data;
        }, []);
        return tableData;
      }
    }
  }
});
</script>

<style module lang="scss">
.tableWrapper {
  max-width: 100%;
  width: 100%;
}
.tableComponent {
  width: 100%;
  border-collapse: collapse;
}
</style>
